<?php
include_once("./repositories/MysqlConnector.php");
include_once("./repositories/MysqlColumnDetector.php");

include_once("./models/OutPutDeErro.class.php");
include_once("./models/Cliente.class.php");

class ClienteRepository {
    public static $nomeDaTabela="TAB_CLIENTE";
    
    public function GetAll() {
        $mysqlColumnDetector = new MysqlColumnDetector();
              
        $mysqlConnector = new MysqlConnector();
	    $mysqlConnector->GetConnectionLink();

        $query = "select COD_CLIENTE, DES_CLIENTE, DES_FANTASIA, NUM_CNPJ from TAB_CLIENTE";
        $resultset = $mysqlConnector->link->query($query);

        $listReturn = [];

        if($resultset) 
        {
            while ($row = $resultset->fetch_object()) {
                $objeto = new Cliente();
                $objeto->COD_CLIENTE = $row->COD_CLIENTE; 
                $objeto->DES_CLIENTE = $row->DES_CLIENTE;
                $objeto->DES_FANTASIA = $row->DES_FANTASIA;
                $objeto->NUM_CNPJ = $row->NUM_CNPJ;

                /*$listaDeColunasDeModulo = $mysqlColumnDetector->GetAllColumnsFromTableNameAndFilter("TAB_CLIENTE", "MOD_");
                foreach ($listaDeColunasDeModulo as $columnName) {
                    $novoModulo = new Modulo();
                    $novoModulo->COLUMN_NAME = $columnName;
                    $novoModulo->HABILITADO = $row[$columnName] == 'S'

                    array_push($objeto->MODULOS, $novoModulo);
                }*/

                $listReturn[] = $objeto;
            }
            
            $resultset->close();
        }

        $mysqlConnector->DisconnectDB();

        return $listReturn;
    }

    
    public function Add($objeto) {
        $mysqlConnector = new MysqlConnector();
	    $mysqlConnector->GetConnectionLink();

        $query = "insert into TAB_CLIENTE (DES_CLIENTE, DES_FANTASIA, NUM_CNPJ) values ('".$objeto->DES_CLIENTE."','".$objeto->DES_FANTASIA."','".$objeto->NUM_CNPJ."')";
        $resultset = $mysqlConnector->link->query($query);

        $rowsAffected = $mysqlConnector->link->affected_rows;

        $mysqlConnector->DisconnectDB();

        return $rowsAffected;
    }

    public function GetClientByCnpj($Cnpj) {
        
        $CNPJ = str_replace("/","",str_replace("-","",str_replace(".","",$Cnpj)));

        if(strlen(trim($CNPJ)) != 14){
            new OutputDeErro(409, "CNPJ inválido.");
        }
        $mysqlConnector = new MysqlConnector();
	    $mysqlConnector->GetConnectionLink();

        $Query = "SELECT COD_CLIENTE,DES_CLIENTE,DES_FANTASIA,NUM_CNPJ FROM ".self::$nomeDaTabela." WHERE REPLACE(REPLACE(REPLACE(TRIM(NUM_CNPJ),'.',''),'-',''),'/','') = '$CNPJ'" ;
        $resultset = $mysqlConnector->link->query($Query);
        
        $row = $resultset->fetch_object();
        if(is_null($row)){
            new OutputDeErro(409, "CNPJ não encontrado");
        } 

        $ClienteRetorno = new Cliente(); 
        $ClienteRetorno->COD_CLIENTE  = $row->COD_CLIENTE;
        $ClienteRetorno->DES_CLIENTE  = $row->DES_CLIENTE;
        $ClienteRetorno->DES_FANTASIA = $row->DES_FANTASIA;
        $ClienteRetorno->NUM_CNPJ     = $row->NUM_CNPJ;

        $mysqlConnector->DisconnectDB();
        return $ClienteRetorno;
    }
}

?>